PAPI_set_thr_specific(3)

NAME
PAPI_set_thr_specific - Store a pointer to a thread specific data structure.

SYNOPSIS

Detailed Description

Prototype:
    #include <papi.h>
     int PAPI_set_thr_specific( int tag, void *ptr );

Parameters
    tag An identifier, the value of which is either PAPI_USR1_TLS or PAPI_USR2_TLS. This identifier indicates which of several data structures associated with this thread is to be accessed.
    ptr A pointer to the memory containing the data structure.

Return values
    PAPI_OK
    PAPI_EINVAL The tag argument is out of range.

In C, PAPI_set_thr_specific will save ptr into an array indexed by tag. There are 2 user available locations and tag can be either PAPI_USR1_TLS or PAPI_USR2_TLS. The array mentioned above is managed by PAPI and allocated to each thread which has called PAPI_thread_init. There is no Fortran equivalent function.

Example:

    int ret;
    RateInfo *state = NULL;
    ret = PAPI_thread_init(pthread_self);
    if (ret != PAPI_OK) handle_error(ret);

    // Do we have the thread specific data setup yet?

    ret = PAPI_get_thr_specific(PAPI_USR1_TLS, (void *) &state);
    if (ret != PAPI_OK || state == NULL) {
        state = (RateInfo *) malloc(sizeof(RateInfo));
        if (state == NULL) return (PAPI_ESYS);
        memset(state, 0, sizeof(RateInfo));
        state->EventSet = PAPI_NULL;
        ret = PAPI_create_eventset(&state->EventSet);
        if (ret != PAPI_OK) return (PAPI_ESYS);
        ret = PAPI_set_thr_specific(PAPI_USR1_TLS, state);
        if (ret != PAPI_OK) return (ret);
    }

See also
    PAPI_register_thread PAPI_thread_init PAPI_thread_id PAPI_get_thr_specific

Author

Generated automatically by Doxygen for PAPI from the source code.